import urllib.request, urllib.error, urllib.parse, json, pprint, string, ssl, time

api_url = "https://api.radb.net/api/"
mnt_pw = "password=MyPlaintextMaintainerPassword"
api_auth = 'Basic XYZXYZXYZXYZXYZXYZXYZXYZXYZXYZXYZXYZXYZXYZXYZXYZXYZXYZ=='
hdrs_ptxt = {'accept': 'text/plain', 'Authorization': api_auth}
hdrs_json = {'accept': 'application/json', 'Authorization': api_auth}
str_timestamp = time.strftime('%Y%m%d  #%H:%M:%SZ', time.gmtime())

def radb_api_req(req_url, req_hdrs, req_data):
	req_req = urllib.request.Request(req_url, req_data, req_hdrs)
	return urllib.request.urlopen(req_req).read()

# print('\n GET objects maint by AS10026: \n')
# get_search_ptxt = radb_api_req(api_url + "radb/search?query-string=MAINT-AS10026&inverse-attribute=mnt-by&" + mnt_pw, hdrs_ptxt, None)
# print(get_search_ptxt.decode())

print('\n GET object plain text example: \n')
get_obj_ptxt = radb_api_req(api_url + "radb/route/42.99.128.0/17AS10026?" + mnt_pw, hdrs_ptxt, None)
routeobj = get_obj_ptxt.decode()
print(routeobj)

def rpsl_get_attrib(routeobj, attrib):
	ln_num = 0
	attrib_begin_pos = -1
	attrib_end_pos = -1
	ro_splitln = routeobj.split("\n")
	for ln in ro_splitln:
		ln_spl = ln.split()
		if len(ln_spl) > 0:
			if ln_spl[0] == attrib:
				attrib_begin_pos = ln_num
		if len(ln) > 0:
			if attrib_begin_pos != -1 and ln_num > attrib_begin_pos: #if we've already found the beginning of the attribute, and we're on a line below the first line of that attrib
				if attrib_end_pos == -1: #if we haven't already found the end of that attrib
					if ln[0] not in string.whitespace: #if the first char of that line isn't whitespace (tabbing due to continued attribute)
						attrib_end_pos = ln_num #we've found the end of the attribute
		ln_num += 1
	attrib_val = ro_splitln[attrib_begin_pos:attrib_end_pos]
	attrib_val = "\n".join(attrib_val)
	return attrib_val

#test get attrib func

#getdscr = rpsl_get_attrib(routeobj, 'descr:')
#print("EXTRACTED descr:")
#print(getdscr)

#getrmks = rpsl_get_attrib(routeobj, 'remarks:')
#print("EXTRACTED remarks:")
#print(getrmks)

def rpsl_set_attrib(routeobj, attrib, val):
	ln_num = 0
	attrib_begin_pos = -1 #maybe use attrib_begin_pos
	attrib_end_pos = -1
	ro_splitln = routeobj.split("\n")
	for ln in ro_splitln:
		ln_spl = ln.split()
		if len(ln_spl) > 0:
			if ln_spl[0] == attrib:
				attrib_begin_pos = ln_num
		if len(ln) > 0:
			if attrib_begin_pos != -1 and ln_num > attrib_begin_pos: #if we've already found the beginning of the attribute, and we're on a line below the first line of that attrib
				if attrib_end_pos == -1: #if we haven't already found the end of that attrib
					if ln[0] not in string.whitespace: #if the first char of that line isn't whitespace (tabbing due to continued attribute)
						attrib_end_pos = ln_num #we've found the end of the attribute
		ln_num += 1
	attrib_val = ro_splitln[attrib_begin_pos:attrib_end_pos]
	attrib_val = "\n".join(attrib_val)
	
	ro_upd = "\n".join(ro_splitln[0:attrib_begin_pos])
	
	#if new val includes multiple lines, need to append tabbing
	val_splln = val.split('\n') # split the new value for the attribute by lines
	val_fmt = [] # new formatted version of the value (including tabbing for lines beyond the first)
	val_ln_num = 0 #value line number
	for valln in val_splln: #for each value line
		valln_fmt = ""
		if val_ln_num > 0:
			valln_fmt = "            " + valln #if we're past the first line, include 12 spaces
		else:
			valln_fmt = valln #if on the first line, no additional spacing needed (we do that when appending the attrib name)
		val_fmt.append(valln_fmt)
		val_ln_num += 1
	val_fmt = '\n'.join(val_fmt)
	
	ro_upd += "\n" + '{:<12}'.format(attrib) + val_fmt + '\n'
	ro_upd += '\n'.join(ro_splitln[attrib_end_pos:len(ro_splitln)])
	
	return ro_upd

#test set attrib func

ro_upd = rpsl_set_attrib(routeobj, 'descr:', 'Telstra Global Internet Services Network Blocks')
ro_upd = rpsl_set_attrib(ro_upd, 'remarks:', 'For SPAM/ABUSE Issue: ipnoc@team.telstra.com\nFor Network Related Issue: ipnoc@team.telstra.com\nFor other issues:  ipnpi@team.telstra.com')
ro_upd = rpsl_set_attrib(ro_upd, 'notify:', 'ipNOC@team.telstra.com')
ro_upd = rpsl_set_attrib(ro_upd, 'admin-c:', 'TI55-AP')
ro_upd = rpsl_set_attrib(ro_upd, 'tech-c:', 'TI54-AP')
ro_upd = rpsl_set_attrib(ro_upd, 'changed:', 'ipNOC@team.telstra.com ' + str_timestamp)
ro_upd = rpsl_set_attrib(ro_upd, 'mnt-by:', 'MAINT-AS64505') #remove this
print("route object updated:")
print(ro_upd)


print('\n submit updated route object: \n')
req_url = api_url + "radb/route?" + mnt_pw
req_data = ro_upd
req_data = req_data.encode()
post_obj = radb_api_req(req_url, hdrs_ptxt, req_data)
pprint.pprint(post_obj.decode())





print('\n remove above example obj: \n')
req_url = api_url + "radb/route?" + mnt_pw
req_data = ro_upd + "delete:     contact@example.com deletereason\n"
req_data = req_data.encode()
post_obj = radb_api_req(req_url, hdrs_ptxt, req_data)
pprint.pprint(post_obj.decode())






# print('\n GET object json example: \n')
# get_obj_json = radb_api_req(api_url + "radb/mntner/MAINT-AS10026?" + mnt_pw, hdrs_json, None)
# print(get_obj_json.decode())

# print('\n GET search plain text example: \n')
# get_search_ptxt = radb_api_req(api_url + "radb/search?query-string=MAINT-AS64505&inverse-attribute=mnt-by&" + mnt_pw, hdrs_ptxt, None)
# print(get_search_ptxt.decode())

# print('\n GET search json example: \n')
# get_search_json = radb_api_req(api_url + "radb/search?query-string=MAINT-AS64505&inverse-attribute=mnt-by&" + mnt_pw, hdrs_json, None)
# print(get_search_json.decode())






# print('\n POST add new objects: \n')
# req_url = api_url + "radb/aut-num?" + mnt_pw
# req_data = """
# route:      0.1.2.3/32
# descr:      descr
# origin:     AS64505
# remarks:    Remark line 1
            # Remark line 2
# notify:     notify@example.com
# mnt-by:     MAINT-AS64505
# changed:    noemail@example.com 20110601  #05:00:00Z
# source:     RADB
# admin-c:    admin-c
# """
# req_data = req_data.encode()
# post_obj = radb_api_req(req_url, hdrs_ptxt, req_data)
# pprint.pprint(post_obj.decode())


# print('\n query existing object: \n')
# get_obj_ptxt = radb_api_req(api_url + "radb/route/0.1.2.3/32AS64505?" + mnt_pw, hdrs_ptxt, None)
# print(get_obj_ptxt.decode())


# print('\n remove above example obj: \n')
# req_url = api_url + "radb/route?" + mnt_pw
# req_data = """
# route:      0.1.2.3/32
# descr:      descr
# origin:     AS64505
# mnt-by:     MAINT-AS64505
# changed:    noemail@example.com 20110601  #05:00:00Z
# source:     RADB
# delete:		contact@example.com deletereason
# """ #these are the only attributes needed to specify a route object to remove
# req_data = req_data.encode()
# post_obj = radb_api_req(req_url, hdrs_ptxt, req_data)
# pprint.pprint(post_obj.decode())






# print('\n POST add new objects: \n')
# req_url = api_url + "radb/aut-num?" + mnt_pw
# req_data = """
# aut-num:    AS64505
# as-name:    ASTEST64505
# descr:      Testing RADb API for documentation
# admin-c:    Me Myself I
# tech-c:     Someone else
# notify:     someone@example.com
# mnt-by:     MAINT-AS64505
# changed:    someone@example.com 20190801
# source:     RADB
# """
# req_data = req_data.encode()
# post_obj = radb_api_req(req_url, hdrs_ptxt, req_data)
# pprint.pprint(post_obj.decode())

# print('\n Update existing objects: \n')
# req_url = api_url + "radb/aut-num?" + mnt_pw
# req_data = """
# aut-num:    AS64505
# as-name:    ASTEST64505
# descr:      UPDATED Testing RADb API for documentation
# admin-c:    Me Myself I
# tech-c:     Someone else
# notify:     someone@example.com
# mnt-by:     MAINT-AS64505
# changed:    someone@example.com 20190801
# source:     RADB
# """
# req_data = req_data.encode()
# post_obj = radb_api_req(req_url, hdrs_ptxt, req_data)
# pprint.pprint(post_obj.decode())

# print('\n Delete existing objects: \n')
# req_url = api_url + "radb/aut-num?" + mnt_pw
# req_data = """
# aut-num:    AS64505
# as-name:    ASTEST64505
# descr:      UPDATED Testing RADb API for documentation
# admin-c:    Me Myself I
# tech-c:     Someone else
# notify:     someone@example.com
# mnt-by:     MAINT-AS64505
# changed:    someone@example.com 20190801
# source:     RADB
# delete:		contact@example.com deletereason
# """
# req_data = req_data.encode()
# post_obj = radb_api_req(req_url, hdrs_ptxt, req_data)
# pprint.pprint(post_obj.decode())
